diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/DbImportDefinedTermCreationMapperBase.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/DbImportDefinedTermCreationMapperBase.java
index 9602b0cf5c..aa5e0fa0ae 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/DbImportDefinedTermCreationMapperBase.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/DbImportDefinedTermCreationMapperBase.java
@@ -1,194 +1,195 @@
-/**
-* Copyright (C) 2007 EDIT
-* European Distributed Institute of Taxonomy
-* http://www.e-taxonomy.eu
-*
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-
-package eu.etaxonomy.cdm.io.common.mapping;
-
-import java.sql.ResultSet;
-import java.sql.SQLException;
-import java.util.UUID;
-
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
-
-import eu.etaxonomy.cdm.io.common.DbImportStateBase;
-import eu.etaxonomy.cdm.model.common.VersionableEntity;
-import eu.etaxonomy.cdm.model.reference.Reference;
-import eu.etaxonomy.cdm.model.term.DefinedTermBase;
-
-/**
- * This class either retrieves a defined Term from the database or creates and saves it in the database.
- * This is done by first checking the according transformer for term attributes map to an existing
- * CDM term (term that is available by static methods in the term classes), if not it tries to retrieve
- * it via its uuid available through the transformer, if not retrievable it tries to retrieve from the
- * database via the original source, if not retrievable it creates the new and stores it in the database.<BR>
- * Subclasses may decide if they implement a function to use the term immediately via
- * {@link #handleTermWithObject(VersionableEntity, DefinedTermBase)}
- *
- * @author a.mueller
- * @since 12.05.2009
- * @param <TERM>The class of the term to be created or retrieved.
- * @param <TERMED>The class of the object the term is added to.
- * @param <STATE>The class of the import state that is available during import.
- */
-public abstract class DbImportDefinedTermCreationMapperBase<TERM extends DefinedTermBase, TERMED extends VersionableEntity, STATE extends DbImportStateBase<?,?>>
-        extends DbImportObjectCreationMapperBase<TERMED, STATE>  {
-
-    private static final Logger logger = LogManager.getLogger(DbImportDefinedTermCreationMapperBase.class);
-
-//******************************* ATTRIBUTES ***************************************/
-	protected String dbTermAttribute;
-	protected String dbLabelAttribute;
-	protected String dbLabelAbbrevAttribute;
-
-//********************************* CONSTRUCTOR ****************************************/
-	/**
-	 * @param mappingImport
-	 */
-	protected DbImportDefinedTermCreationMapperBase(String dbIdAttribute, String termNamespace, String dbTermAttribute, String dbLabelAttribute, String dbLabelAbbrevAttribute) {
-		super(dbIdAttribute, termNamespace);
-		this.dbTermAttribute = dbTermAttribute;
-		this.dbLabelAttribute = dbLabelAttribute;
-		this.dbLabelAbbrevAttribute = dbLabelAbbrevAttribute;
-	}
-
-//************************************ METHODS *******************************************/
-
-	@Override
-	public TERMED invoke(ResultSet rs, TERMED noObject) throws SQLException {
-		String key = getKeyString(rs);
-		if (key != null){
-			TERM definedTerm = getDefinedTermIfExist(rs);
-			if (definedTerm == null){
-				definedTerm = createDefinedTerm(rs);
-				Reference citation = null;
-				getState().getCurrentIO().addOriginalSource(rs, definedTerm, dbIdAttribute, objectToCreateNamespace, citation);
-
-				UUID transformerUuid = getUuidFromTransformer(rs);
-				if (transformerUuid != null){
-					definedTerm.setUuid(transformerUuid);
-				}
-				getState().getCurrentIO().getTermService().save(definedTerm);
-				saveTermToState(definedTerm);
-				if (transformerUuid == null){
-					getState().addRelatedObject(objectToCreateNamespace, getKeyString(rs), definedTerm);
-				}
-			}
-			handleTermWithObject(noObject, definedTerm);
-		}
-		return noObject;
-	}
-
-	private void makeUuid(ResultSet rs, TERM definedTerm) throws SQLException {
-		UUID uuid = getUuidFromTransformer(rs);
-		if (uuid != null){
-			definedTerm.setUuid(uuid);
-		}
-	}
-
-	protected abstract TERM createDefinedTerm(ResultSet rs) throws SQLException;
-
-	protected abstract void handleTermWithObject(TERMED termed, TERM term);
-
-	/**
-	 * Returns the term if it is available via the transformer, or via the state (uuidMap or relatedObject)
-	 */
-	private TERM getDefinedTermIfExist(ResultSet rs) throws SQLException {
-		//get object from transformer, return if not null
-		TERM definedTerm = getTermFromTransformer(rs);
-		if (definedTerm == null){
-			//if null get uuid from transformer
-			UUID uuidTerm = getUuidFromTransformer(rs);
-			if (uuidTerm != null){
-				definedTerm = getTermByUuid(uuidTerm, rs);
-			}else{
-				definedTerm = getTermByIdentifier(rs);
-			}
-		}
-		return definedTerm;
-	}
-
-	protected TERM getTermByIdentifier(ResultSet rs) throws SQLException {
-		//get object from stat.featur map
-		String key = getKeyString(rs);
-		if (key == null){
-			return null;
-		}
-		TERM term = (TERM)getState().getRelatedObject(objectToCreateNamespace, key);
-		return term;
-	}
-
-	protected TERM getTermByUuid(UUID uuidTerm, ResultSet rs) throws SQLException{
-		TERM term = getTermFromState(uuidTerm);
-		if (term == null){
-			term = (TERM)getState().getCurrentIO().getTermService().find(uuidTerm);
-			if (term != null){
-				saveTermToState(term);
-			}
-		}
-		return term;
-	}
-
-	/**
-	 * Saves the defined term to the state
-	 */
-	protected abstract void saveTermToState(TERM term);
-
-	protected abstract TERM getTermFromState(UUID uuid);
-
-	protected UUID getUuidFromTransformer(ResultSet rs) throws SQLException{
-		IInputTransformer transformer = getTransformer();
-		String key = getKeyString(rs);
-		UUID uuid;
-		try {
-			uuid = getUuidFromTransformer(key, transformer);
-		} catch (UndefinedTransformerMethodException e) {
-			logger.warn(e.getMessage());
-			return null;
-		}
-		return uuid;
-	}
-
-	protected abstract UUID getUuidFromTransformer(String key, IInputTransformer transformer) throws UndefinedTransformerMethodException;
-
-	protected TERM getTermFromTransformer(ResultSet rs) throws SQLException{
-		IInputTransformer transformer = getTransformer();
-		String key = getKeyString(rs);
-		TERM term;
-		try {
-			term = getTermFromTransformer(key, transformer);
-		} catch (UndefinedTransformerMethodException e) {
-			logger.warn(e.getMessage());
-			return null;
-		}
-		return term;
-	}
-
-	protected abstract TERM getTermFromTransformer(String key, IInputTransformer transformer) throws UndefinedTransformerMethodException;
-
-	protected String getKeyString(ResultSet rs) throws SQLException {
-		Object oKey = rs.getString(dbIdAttribute);
-		if (oKey == null){
-			return null;
-		}
-		String key = String.valueOf(oKey);
-		key = key.trim();
-		return key;
-	}
-
-	@Override
-	protected TERMED doInvoke(ResultSet rs, TERMED createdObject)
-			throws SQLException {
-		return createdObject; //not needed because invoke is implemented separately
-	}
-
-	@Override
-	protected TERMED createObject(ResultSet rs) throws SQLException {
-		logger.warn("Never should read this");
-		return null; //not needed, object is created in createDefineTerm(rs)
-	}
-}
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+
+package eu.etaxonomy.cdm.io.common.mapping;
+
+import java.sql.ResultSet;
+import java.sql.SQLException;
+import java.util.UUID;
+
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
+
+import eu.etaxonomy.cdm.io.common.DbImportStateBase;
+import eu.etaxonomy.cdm.model.common.VersionableEntity;
+import eu.etaxonomy.cdm.model.reference.Reference;
+import eu.etaxonomy.cdm.model.term.DefinedTermBase;
+
+/**
+ * This class either retrieves a defined Term from the database or creates and saves it in the database.
+ * This is done by first checking the according transformer for term attributes map to an existing
+ * CDM term (term that is available by static methods in the term classes), if not it tries to retrieve
+ * it via its uuid available through the transformer, if not retrievable it tries to retrieve from the
+ * database via the original source, if not retrievable it creates the new and stores it in the database.<BR>
+ * Subclasses may decide if they implement a function to use the term immediately via
+ * {@link #handleTermWithObject(VersionableEntity, DefinedTermBase)}
+ *
+ * @author a.mueller
+ * @since 12.05.2009
+ * @param <TERM>The class of the term to be created or retrieved.
+ * @param <TERMED>The class of the object the term is added to.
+ * @param <STATE>The class of the import state that is available during import.
+ */
+public abstract class DbImportDefinedTermCreationMapperBase<TERM extends DefinedTermBase, TERMED extends VersionableEntity, STATE extends DbImportStateBase<?,?>>
+        extends DbImportObjectCreationMapperBase<TERMED, STATE>  {
+
+    private static final Logger logger = LogManager.getLogger();
+
+//******************************* ATTRIBUTES ***************************************/
+	protected String dbTermAttribute;
+	protected String dbLabelAttribute;
+	protected String dbLabelAbbrevAttribute;
+
+//********************************* CONSTRUCTOR ****************************************/
+	/**
+	 * @param mappingImport
+	 */
+	protected DbImportDefinedTermCreationMapperBase(String dbIdAttribute, String termNamespace, String dbTermAttribute, String dbLabelAttribute, String dbLabelAbbrevAttribute) {
+		super(dbIdAttribute, termNamespace);
+		this.dbTermAttribute = dbTermAttribute;
+		this.dbLabelAttribute = dbLabelAttribute;
+		this.dbLabelAbbrevAttribute = dbLabelAbbrevAttribute;
+	}
+
+//************************************ METHODS *******************************************/
+
+	@Override
+	public TERMED invoke(ResultSet rs, TERMED noObject) throws SQLException {
+		String key = getKeyString(rs);
+		if (key != null){
+			TERM definedTerm = getDefinedTermIfExist(rs);
+			if (definedTerm == null){
+				definedTerm = createDefinedTerm(rs);
+				Reference citation = null;
+				getState().getCurrentIO().addOriginalSource(rs, definedTerm, dbIdAttribute, objectToCreateNamespace, citation);
+
+				UUID transformerUuid = getUuidFromTransformer(rs);
+				if (transformerUuid != null){
+					definedTerm.setUuid(transformerUuid);
+				}
+				getState().getCurrentIO().getTermService().save(definedTerm);
+				saveTermToState(definedTerm);
+				if (transformerUuid == null){
+					getState().addRelatedObject(objectToCreateNamespace, getKeyString(rs), definedTerm);
+				}
+			}
+			handleTermWithObject(noObject, definedTerm);
+		}
+		return noObject;
+	}
+
+	private void makeUuid(ResultSet rs, TERM definedTerm) throws SQLException {
+		UUID uuid = getUuidFromTransformer(rs);
+		if (uuid != null){
+			definedTerm.setUuid(uuid);
+		}
+	}
+
+	protected abstract TERM createDefinedTerm(ResultSet rs) throws SQLException;
+
+	protected abstract void handleTermWithObject(TERMED termed, TERM term);
+
+	/**
+	 * Returns the term if it is available via the transformer, or via the state (uuidMap or relatedObject)
+	 */
+	private TERM getDefinedTermIfExist(ResultSet rs) throws SQLException {
+		//get object from transformer, return if not null
+		TERM definedTerm = getTermFromTransformer(rs);
+		if (definedTerm == null){
+			//if null get uuid from transformer
+			UUID uuidTerm = getUuidFromTransformer(rs);
+			if (uuidTerm != null){
+				definedTerm = getTermByUuid(uuidTerm, rs);
+			}else{
+				definedTerm = getTermByIdentifier(rs);
+			}
+		}
+		return definedTerm;
+	}
+
+	protected TERM getTermByIdentifier(ResultSet rs) throws SQLException {
+		//get object from stat.featur map
+		String key = getKeyString(rs);
+		if (key == null){
+			return null;
+		}
+		TERM term = (TERM)getState().getRelatedObject(objectToCreateNamespace, key);
+		return term;
+	}
+
+	protected TERM getTermByUuid(UUID uuidTerm, ResultSet rs) throws SQLException{
+		TERM term = getTermFromState(uuidTerm);
+		if (term == null){
+			term = (TERM)getState().getCurrentIO().getTermService().find(uuidTerm);
+			if (term != null){
+				saveTermToState(term);
+			}
+		}
+		return term;
+	}
+
+	/**
+	 * Saves the defined term to the state
+	 */
+	protected abstract void saveTermToState(TERM term);
+
+	protected abstract TERM getTermFromState(UUID uuid);
+
+	protected UUID getUuidFromTransformer(ResultSet rs) throws SQLException{
+		IInputTransformer transformer = getTransformer();
+		String key = getKeyString(rs);
+		UUID uuid;
+		try {
+			uuid = getUuidFromTransformer(key, transformer);
+		} catch (UndefinedTransformerMethodException e) {
+			logger.warn(e.getMessage());
+			return null;
+		}
+		return uuid;
+	}
+
+	protected abstract UUID getUuidFromTransformer(String key, IInputTransformer transformer) throws UndefinedTransformerMethodException;
+
+	protected TERM getTermFromTransformer(ResultSet rs) throws SQLException{
+		IInputTransformer transformer = getTransformer();
+		String key = getKeyString(rs);
+		TERM term;
+		try {
+			term = getTermFromTransformer(key, transformer);
+		} catch (UndefinedTransformerMethodException e) {
+			logger.warn(e.getMessage());
+			return null;
+		}
+		return term;
+	}
+
+	protected abstract TERM getTermFromTransformer(String key, IInputTransformer transformer) throws UndefinedTransformerMethodException;
+
+	protected String getKeyString(ResultSet rs) throws SQLException {
+		Object oKey = rs.getString(dbIdAttribute);
+		if (oKey == null){
+			return null;
+		}
+		String key = String.valueOf(oKey);
+		key = key.trim();
+		return key;
+	}
+
+	@Override
+	protected TERMED doInvoke(ResultSet rs, TERMED createdObject)
+			throws SQLException {
+		return createdObject; //not needed because invoke is implemented separately
+	}
+
+	@Override
+	protected TERMED createObject(ResultSet rs) throws SQLException {
+		logger.warn("Never should read this");
+		return null; //not needed, object is created in createDefineTerm(rs)
+	}
+}
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/DbImportDescriptionElementCreationMapperBase.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/DbImportDescriptionElementCreationMapperBase.java
index 552a82246a..8d79d4d7b2 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/DbImportDescriptionElementCreationMapperBase.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/DbImportDescriptionElementCreationMapperBase.java
@@ -1,137 +1,138 @@
-/**
-* Copyright (C) 2007 EDIT
-* European Distributed Institute of Taxonomy
-* http://www.e-taxonomy.eu
-*
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-
-package eu.etaxonomy.cdm.io.common.mapping;
-
-import java.sql.ResultSet;
-import java.sql.SQLException;
-import java.util.Set;
-
-import org.apache.commons.lang.StringUtils;
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
-
-import eu.etaxonomy.cdm.io.common.DbImportStateBase;
-import eu.etaxonomy.cdm.model.common.CdmBase;
-import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
-import eu.etaxonomy.cdm.model.description.TaxonDescription;
-import eu.etaxonomy.cdm.model.reference.OriginalSourceType;
-import eu.etaxonomy.cdm.model.reference.Reference;
-import eu.etaxonomy.cdm.model.taxon.Synonym;
-import eu.etaxonomy.cdm.model.taxon.Taxon;
-import eu.etaxonomy.cdm.model.taxon.TaxonBase;
-
-/**
- * @author a.mueller
- * @since 11.03.2010
- */
-public abstract class DbImportDescriptionElementCreationMapperBase<ELEMENT extends DescriptionElementBase, STATE extends DbImportStateBase<?,?>> extends DbImportObjectCreationMapperBase<ELEMENT, STATE> {
-
-    private static final Logger logger = LogManager.getLogger(DbImportDescriptionElementCreationMapperBase.class);
-
-//******************************* ATTRIBUTES ***************************************/
-
-	protected String taxonNamespace;
-	protected String dbTaxonFkAttribute;
-	protected boolean isImageGallery = false;
-	protected String dbCitationAttribute;  //if there is a single source available
-	protected String sourceNamespace;
-	protected String dbMicroCitationAttribute;
-
-//********************************* CONSTRUCTOR ****************************************/
-
-	protected DbImportDescriptionElementCreationMapperBase(String dbIdAttribute, String objectToCreateNamespace, String dbTaxonFkAttribute, String taxonNamespace) {
-		super(dbIdAttribute, objectToCreateNamespace);
-		this.taxonNamespace = taxonNamespace;
-		this.dbTaxonFkAttribute = dbTaxonFkAttribute;
-	}
-
-//************************************ METHODS *******************************************/
-
-	public DbImportDescriptionElementCreationMapperBase<ELEMENT,STATE> setSource(String dbCitationAttribute, String sourceNamespace, String dbMicroCitationAttribute){
-		this.dbCitationAttribute = dbCitationAttribute;
-		this.sourceNamespace = sourceNamespace;
-		this.dbMicroCitationAttribute = dbMicroCitationAttribute;
-		return this;
-	}
-
-	@Override
-	protected ELEMENT doInvoke(ResultSet rs, ELEMENT element) throws SQLException {
-		Taxon taxon = getAcceptedTaxon(rs);
-		if (taxon != null){
-			element = addDescriptionElement(taxon, element);
-		}else{
-			logger.info("Taxon could not be determined. Description element was not add to any description or taxon");
-		}
-		//Source
-		if (StringUtils.isNotBlank(dbCitationAttribute)){
-			addSource(rs, element);
-		}
-		return element;
-	}
-
-	private void addSource(ResultSet rs, ELEMENT element) throws SQLException {
-		String microCitation = getStringDbValue(rs, dbMicroCitationAttribute);
-		Reference citation = (Reference) getState().getRelatedObject(sourceNamespace, String.valueOf(rs.getObject(dbCitationAttribute)));
-		element.addSource(OriginalSourceType.PrimaryTaxonomicSource, null, null, citation, microCitation);
-	}
-
-	protected Taxon getAcceptedTaxon(ResultSet rs) throws SQLException {
-		String taxonFk = getForeignKey(rs, dbTaxonFkAttribute);
-		TaxonBase<?> taxonBase = (TaxonBase<?>)getRelatedObject(taxonNamespace, taxonFk);
-		Taxon taxon = null;
-		if (taxonBase == null){
-			logger.warn("TaxonBase not found: " + taxonFk);
-		}else if (taxonBase instanceof Taxon){
-			taxon = (Taxon)taxonBase;
-
-		}else if (taxonBase instanceof Synonym){
-			Synonym synonym = CdmBase.deproxy(taxonBase, Synonym.class);
-			Taxon accTaxon = synonym.getAcceptedTaxon();
-			if (accTaxon == null){
-				logger.warn("Synonym '" + synonym.getTitleCache() + "' ("+ taxonFk + ") has no accepted taxon. Can't define a taxon to add the description element to");
-			}else {
-				taxon = accTaxon;
-			}
-		}else{ //null
-			throw new IllegalStateException("TaxonBase must either be null, Taxon or Synonym but was something else");
-		}
-		return taxon;
-	}
-
-	/**
-	 * Adds a description element to the taxon's first description which is not an image gallery.
-	 * If no such description exists a new one is generated. Returns the element or, if null if taxon is null.
-	 */
-	protected ELEMENT addDescriptionElement(Taxon taxon, ELEMENT element) {
-		if (taxon == null){
-			return null;
-		}else{
-			TaxonDescription description = getTaxonDescription(taxon, isImageGallery);
-			description.addElement(element);
-			return element;
-		}
-	}
-
-	protected TaxonDescription getTaxonDescription(Taxon taxon, boolean isImageGallery) {
-		Set<TaxonDescription> descriptions = taxon.getDescriptions();
-		TaxonDescription description = null;
-		if (descriptions.size() > 0){
-			for (TaxonDescription desc : descriptions){
-				if ( desc.isImageGallery() == isImageGallery ){
-					description = desc;
-					break;
-				}
-			}
-		}
-		if (description == null){
-			description = TaxonDescription.NewInstance(taxon, isImageGallery);
-		}
-		return description;
-	}
-}
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+
+package eu.etaxonomy.cdm.io.common.mapping;
+
+import java.sql.ResultSet;
+import java.sql.SQLException;
+import java.util.Set;
+
+import org.apache.commons.lang.StringUtils;
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
+
+import eu.etaxonomy.cdm.io.common.DbImportStateBase;
+import eu.etaxonomy.cdm.model.common.CdmBase;
+import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
+import eu.etaxonomy.cdm.model.description.TaxonDescription;
+import eu.etaxonomy.cdm.model.reference.OriginalSourceType;
+import eu.etaxonomy.cdm.model.reference.Reference;
+import eu.etaxonomy.cdm.model.taxon.Synonym;
+import eu.etaxonomy.cdm.model.taxon.Taxon;
+import eu.etaxonomy.cdm.model.taxon.TaxonBase;
+
+/**
+ * @author a.mueller
+ * @since 11.03.2010
+ */
+public abstract class DbImportDescriptionElementCreationMapperBase<ELEMENT extends DescriptionElementBase, STATE extends DbImportStateBase<?,?>> extends DbImportObjectCreationMapperBase<ELEMENT, STATE> {
+
+    private static final Logger logger = LogManager.getLogger();
+
+//******************************* ATTRIBUTES ***************************************/
+
+	protected String taxonNamespace;
+	protected String dbTaxonFkAttribute;
+	protected boolean isImageGallery = false;
+	protected String dbCitationAttribute;  //if there is a single source available
+	protected String sourceNamespace;
+	protected String dbMicroCitationAttribute;
+
+//********************************* CONSTRUCTOR ****************************************/
+
+	protected DbImportDescriptionElementCreationMapperBase(String dbIdAttribute, String objectToCreateNamespace, String dbTaxonFkAttribute, String taxonNamespace) {
+		super(dbIdAttribute, objectToCreateNamespace);
+		this.taxonNamespace = taxonNamespace;
+		this.dbTaxonFkAttribute = dbTaxonFkAttribute;
+	}
+
+//************************************ METHODS *******************************************/
+
+	public DbImportDescriptionElementCreationMapperBase<ELEMENT,STATE> setSource(String dbCitationAttribute, String sourceNamespace, String dbMicroCitationAttribute){
+		this.dbCitationAttribute = dbCitationAttribute;
+		this.sourceNamespace = sourceNamespace;
+		this.dbMicroCitationAttribute = dbMicroCitationAttribute;
+		return this;
+	}
+
+	@Override
+	protected ELEMENT doInvoke(ResultSet rs, ELEMENT element) throws SQLException {
+		Taxon taxon = getAcceptedTaxon(rs);
+		if (taxon != null){
+			element = addDescriptionElement(taxon, element);
+		}else{
+			logger.info("Taxon could not be determined. Description element was not add to any description or taxon");
+		}
+		//Source
+		if (StringUtils.isNotBlank(dbCitationAttribute)){
+			addSource(rs, element);
+		}
+		return element;
+	}
+
+	private void addSource(ResultSet rs, ELEMENT element) throws SQLException {
+		String microCitation = getStringDbValue(rs, dbMicroCitationAttribute);
+		Reference citation = (Reference) getState().getRelatedObject(sourceNamespace, String.valueOf(rs.getObject(dbCitationAttribute)));
+		element.addSource(OriginalSourceType.PrimaryTaxonomicSource, null, null, citation, microCitation);
+	}
+
+	protected Taxon getAcceptedTaxon(ResultSet rs) throws SQLException {
+		String taxonFk = getForeignKey(rs, dbTaxonFkAttribute);
+		TaxonBase<?> taxonBase = (TaxonBase<?>)getRelatedObject(taxonNamespace, taxonFk);
+		Taxon taxon = null;
+		if (taxonBase == null){
+			logger.warn("TaxonBase not found: " + taxonFk);
+		}else if (taxonBase instanceof Taxon){
+			taxon = (Taxon)taxonBase;
+
+		}else if (taxonBase instanceof Synonym){
+			Synonym synonym = CdmBase.deproxy(taxonBase, Synonym.class);
+			Taxon accTaxon = synonym.getAcceptedTaxon();
+			if (accTaxon == null){
+				logger.warn("Synonym '" + synonym.getTitleCache() + "' ("+ taxonFk + ") has no accepted taxon. Can't define a taxon to add the description element to");
+			}else {
+				taxon = accTaxon;
+			}
+		}else{ //null
+			throw new IllegalStateException("TaxonBase must either be null, Taxon or Synonym but was something else");
+		}
+		return taxon;
+	}
+
+	/**
+	 * Adds a description element to the taxon's first description which is not an image gallery.
+	 * If no such description exists a new one is generated. Returns the element or, if null if taxon is null.
+	 */
+	protected ELEMENT addDescriptionElement(Taxon taxon, ELEMENT element) {
+		if (taxon == null){
+			return null;
+		}else{
+			TaxonDescription description = getTaxonDescription(taxon, isImageGallery);
+			description.addElement(element);
+			return element;
+		}
+	}
+
+	protected TaxonDescription getTaxonDescription(Taxon taxon, boolean isImageGallery) {
+		Set<TaxonDescription> descriptions = taxon.getDescriptions();
+		TaxonDescription description = null;
+		if (descriptions.size() > 0){
+			for (TaxonDescription desc : descriptions){
+				if ( desc.isImageGallery() == isImageGallery ){
+					description = desc;
+					break;
+				}
+			}
+		}
+		if (description == null){
+			description = TaxonDescription.NewInstance(taxon, isImageGallery);
+		}
+		return description;
+	}
+}
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/DbImportDescriptionElementSourceCreationMapper.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/DbImportDescriptionElementSourceCreationMapper.java
index 2e9083afcb..ab036b1e1a 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/DbImportDescriptionElementSourceCreationMapper.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/DbImportDescriptionElementSourceCreationMapper.java
@@ -13,7 +13,8 @@ import java.sql.ResultSet;
 import java.sql.SQLException;
 
 import org.apache.commons.lang.StringUtils;
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
 
 import eu.etaxonomy.cdm.io.common.DbImportStateBase;
 import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
@@ -28,8 +29,9 @@ import eu.etaxonomy.cdm.model.reference.Reference;
  * @since 11.03.2010
  */
 public class DbImportDescriptionElementSourceCreationMapper extends DbImportObjectCreationMapperBase<DescriptionElementSource, DbImportStateBase<?,?>> {
-	@SuppressWarnings("unused")
-	private static final Logger logger = LogManager.getLogger(DbImportDescriptionElementSourceCreationMapper.class);
+
+    @SuppressWarnings("unused")
+	private static final Logger logger = LogManager.getLogger();
 
 //**************************** FACTORY METHOD ***********************************************/
 
